# Shane's Acquisition Understander
# http://www.zope.org/Members/chrisw/showaq

legend = """\
+-----------------------------+
| \ ... containment (aq_self) |
| | ... context (aq_parent)   |
| () .. not actually searched |
+-----------------------------+
| containment before context! |
| security: containment only  |
+-----------------------------+
|
"""

def showaq( self ):
    'Acquisition Understander'
    return legend + showaq_( self )

def showaq_( self, indent='' ):
    rval = "" 
    obj = self
    base = getattr(obj, 'aq_base', obj)
    try: id = base.id
    except: id = str(base)
    try: id = id()
    except: pass

    if hasattr(obj, 'aq_self'):
        if hasattr(obj.aq_self, 'aq_self'):
            rval = rval + indent + "(" + id + ")\n"
            rval = rval + indent + "|  \\\n"
            rval = rval + showaq_(obj.aq_self, '|   ' + indent)
            rval = rval + indent + "|\n"
        if hasattr(obj, 'aq_parent'):
            rval = rval + indent + id + "\n"
            rval = rval + indent + "|\n"
            rval = rval + showaq_(obj.aq_parent, indent)
    else:
        rval = rval + indent + id + "\n"
    return rval

